/* Procedure para gerar contas a receber*/
IF EXISTS (SELECT * FROM sysobjects O, sysusers U
           WHERE
            o.name = 'GERA_CONTA'  and
            type = 'P'                        and
            u.uid = o.uid                     and
            u.name = USER)

   DROP PROCEDURE GERA_CONTA;
GO

CREATE PROCEDURE GERA_CONTA(
   @P_IDENTRSAID   VARCHAR(1),
   @P_CDEMPRESA    VARCHAR(2),
   @P_CDFILIAL     VARCHAR(4),
   @P_FILIORIGEM   VARCHAR(4),
   @P_NRLANCTONF   VARCHAR(10),
   @P_NRLANBOL     VARCHAR(20),
   @P_VALORDOC     CHAR(10),
   @P_CDTIPOOPER   VARCHAR(2),
   @P_CDSERIE      VARCHAR(5),
   @P_IDORIGDEST   VARCHAR(1),
   @P_CDCLIEFORN   VARCHAR(21),
   @P_DTEMISSAO    DATETIME,
   @P_DTENTRSAID   DATETIME,
   @P_STATUSNF     VARCHAR(1),
   @P_CDVENDEDOR   VARCHAR(4),
   @P_DTLANCNF     DATETIME,
   @P_DTVENCCONTA  DATETIME,
   @P_CDTIPORECE   VARCHAR(3),
   @P_DESCCONTA    VARCHAR(40),
   @P_NRCHEQUEVEND VARCHAR(6),
   @P_CDBANCHEQVEN VARCHAR(3),
   @P_CDAGECHEQVEN VARCHAR(5),
   @P_CDCNTCHEQVEN VARCHAR(16),
   @P_NRINSJURCHEQ VARCHAR(20),
   @P_IDSTATCONTA  VARCHAR(1),
   @P_CDTPAJUSTE   VARCHAR(4),
   @P_VRAJUSTE     DOUBLE PRECISION,
   @P_CDOPERADOR   VARCHAR(12),
   @P_QTPARCELAS   DOUBLE PRECISION)
AS
  DECLARE @V_CDINSCMUNI    VARCHAR(16);
  DECLARE @V_CDINSCESTA    VARCHAR(16);
  DECLARE @V_CDCLASSFINA   VARCHAR(6);
  DECLARE @V_NRLANCCONT    VARCHAR(20);
  DECLARE @V_CDTIPOCONTA   VARCHAR(6);
  DECLARE @V_DSTPCTRECEB   VARCHAR(40);
  DECLARE @V_DESCCONTA     VARCHAR(40);
  DECLARE @V_VRPEMULTA     DOUBLE PRECISION;
  DECLARE @V_VRPEMORA      DOUBLE PRECISION;
  DECLARE @V_NRDOCUMENTO   VARCHAR(20);
  DECLARE @V_CONCAT1       VARCHAR(30);
  DECLARE @ANO             VARCHAR(10);
  DECLARE @MES             VARCHAR(10);
  DECLARE @ANOMES          VARCHAR(10);
  DECLARE @V_COUNT         DOUBLE PRECISION;
  DECLARE @V_VRCONTA       DOUBLE PRECISION;
  DECLARE @V_VRACUMCONTA   DOUBLE PRECISION;
  DECLARE @V_VRAJUSTE      DOUBLE PRECISION;
  DECLARE @V_VRACUMAJUSTE  DOUBLE PRECISION;
  DECLARE @V_VRRATEIOCONTA DOUBLE PRECISION;
  DECLARE @V_DTVENC        DATE;
  DECLARE @V_QTPARCELAS    DOUBLE PRECISION;
  DECLARE @V_NRLANBOL      VARCHAR(10);
  DECLARE @V_NRSEQVENREC   VARCHAR(2);
  DECLARE @V_VRNEXTLANBOL  DOUBLE PRECISION;
BEGIN
   BEGIN
      SELECT @V_CDINSCMUNI = MAX(CDINSCMUNI),
             @V_CDINSCESTA = MAX(CDINSCESTA)
        FROM FILIAL
       WHERE CDFILIAL = @P_FILIORIGEM;
   END;

   BEGIN
      SELECT @V_CDTIPOCONTA = MAX(TR.CDTPCTRECEB),
             @V_DESCCONTA   = MAX(TC.DSTPCTRECEB)
        FROM TIPORECE TR, TIPOCTRECEBER TC
       WHERE TR.CDTIPORECE  = @P_CDTIPORECE AND
             TR.CDTPCTRECEB = TC.CDTPCTRECEB;
   END;

   IF @V_CDTIPOCONTA IS NOT NULL BEGIN
      IF @P_DESCCONTA IS NOT NULL BEGIN
         SET @V_DESCCONTA = @P_DESCCONTA;
      END;

      BEGIN
         SELECT @V_VRPEMULTA = MAX(VRPEMULBCLI),
                @V_VRPEMORA  = MAX(VRPEMORBCLI)
          FROM  CLIENTE
         WHERE  CDCLIENTE = @P_CDCLIEFORN;


         SELECT @V_VRPEMULTA = MAX(VRPEMULEMPR),
                @V_VRPEMORA  = MAX(VRPEMOREMPR)
           FROM EMPRESA
          WHERE (CDEMPRESA    = @P_CDEMPRESA);
      END;

      BEGIN
         SELECT @V_CDCLASSFINA = MAX(CDCLASSFINA)
           FROM TIPOCTRECEBER
          WHERE CDTPCTRECEB = @V_CDTIPOCONTA;
      END;
      
      /* Busca o nmero do lanamento contbil*/
      SET @P_DTEMISSAO = CONVERT(VARCHAR, @P_DTEMISSAO, 12)

      SET @ANO = MONTH(@P_DTEMISSAO);
      SET @MES = YEAR(@P_DTEMISSAO);
      SET @ANOMES = @ANO+@MES;

      SET @V_NRLANBOL = @P_NRLANBOL;

      SET @V_CONCAT1 = 'LANCCONTABIL'+@P_CDEMPRESA+@ANOMES;
      EXEC NOVO_CODIGO @V_CONCAT1, @P_SEQUENCIAL = @V_NRLANCCONT OUTPUT;
      SET @V_NRLANCCONT = SUBSTRING(@V_NRLANCCONT, 9, 12);

      /* Busca o nmero do documento */
      EXEC NOVO_CODIGO 'NRNOTAFISCREC', @P_SEQUENCIAL = @V_NRDOCUMENTO OUTPUT;
      SET @V_NRDOCUMENTO = SUBSTRING(@V_NRDOCUMENTO, 14, 7);

      EXEC INCLUI_NOTA @P_IDENTRSAID, @P_CDEMPRESA, @V_CDINSCESTA, @V_CDINSCMUNI, @P_CDFILIAL,   @P_NRLANCTONF,
                       @P_FILIORIGEM, @P_VALORDOC,  @P_CDTIPOOPER,  @P_IDORIGDEST, @P_CDCLIEFORN, @V_NRDOCUMENTO,
                       @P_CDSERIE,    @P_DTEMISSAO, @P_DTENTRSAID, '',            @P_CDVENDEDOR, '',
                       @P_STATUSNF,   @P_DTLANCNF;

      /*SOMA DOS VALORES DE TODAS AS CONTAS LANADAS (PARA VERIFICAR DIVERGNCIAS DE VALORES)*/
      SET @V_VRACUMCONTA = 0;
      /*SOMA DOS VALORES DE TODOS OS AJUSTES LANADOS (PARA VERIFICAR DIVERGNCIAS DE VALORES)*/
      SET @V_VRACUMAJUSTE = 0;
      /*VALOR DE CADA CONTA*/
      SET @V_VRCONTA = ROUND(@P_VALORDOC/@P_QTPARCELAS, 2);
      /*VALOR DE CADA AJUSTE*/
      SET @V_VRAJUSTE = ROUND(@P_VRAJUSTE/@P_QTPARCELAS, 2);
      /*DATA DE VENCIMENTO*/
      SET @V_DTVENC = @P_DTVENCCONTA;

      SET @V_COUNT = 1;

      /*GERA O NMERO DE CONTAS INDICADO PELO PARMETRO QTPARCELAS*/
      WHILE (@V_COUNT <= @P_QTPARCELAS) BEGIN
         /*ACUMULAO DE VALORES*/
         SET @V_VRACUMCONTA = @V_VRACUMCONTA + @V_VRCONTA;
         SET @V_VRACUMAJUSTE = @V_VRACUMAJUSTE + @V_VRAJUSTE;

         /*JOGA AS DIFERENAS PARA A LTIMA PARCELA*/
         IF (@V_COUNT + 1 > @P_QTPARCELAS) BEGIN
            SET @V_VRCONTA = @V_VRCONTA + (@P_VALORDOC - @V_VRACUMCONTA);
            SET @V_VRAJUSTE = @V_VRAJUSTE + (@P_VRAJUSTE - @V_VRACUMAJUSTE);
         END;

         EXEC GERA_BOLETOS_REC @V_NRLANBOL/*MESMO CAMPO Q TA VAZIO*/,     @P_CDFILIAL,     @P_CDCLIEFORN,
                               @P_CDEMPRESA,    @V_VRCONTA,     @V_DTVENC,
                               @P_CDTIPORECE,   @P_NRCHEQUEVEND, @P_CDBANCHEQVEN,
                               @P_CDAGECHEQVEN, @P_CDCNTCHEQVEN;

         EXEC ATUALIZA_FLUXO_DE_CAIXA @P_CDEMPRESA,
                                      @P_FILIORIGEM,
                                      @V_DTVENC,
                                      'E',
                                      @V_CDCLASSFINA,
                                      @V_VRCONTA,
                                      0;

         SET @V_NRSEQVENREC = RIGHT(REPLICATE('0',2) + CONVERT(VARCHAR, @V_COUNT),2);

         EXEC INCLUI_CONTA @P_IDENTRSAID,  @P_CDEMPRESA, @P_CDFILIAL, @P_NRLANCTONF,
                           @V_NRSEQVENREC, @V_VRCONTA,  @V_DTVENC,
                           @V_DESCCONTA,   @V_CDTIPOCONTA,
                           0,              '00',         @P_IDSTATCONTA,
                           @V_CDCLASSFINA, @V_NRLANBOL;

         /*GERA O AJUSTE DA CONTA A RECEBER*/
         IF (@P_CDTPAJUSTE IS NOT NULL) AND (@V_VRAJUSTE <> 0) BEGIN
            /*INSERE O AJUSTE*/
            INSERT INTO AJCTRECEBER
                  (CDFILIAL, NRLANCTONF, NRSEQVENREC, NRPARCELAREC, DTAJUSTEREC, CDAJUCTREC,
                   DSAJUSTEREC, VRAJUSTEREC, CDCLASSFINA, CDEMMFAJCNTR, CDFIMFAJCNTR,
                   DTMOVFLUXO, IDMOVFLUXO, CDECTBAJREC, NRLCTBAJREC)
            VALUES
                  (@P_CDFILIAL, @P_NRLANCTONF, @V_NRSEQVENREC, '00', @V_DTVENC, @P_CDTPAJUSTE,
                   'Ajuste', @V_VRAJUSTE, @V_CDCLASSFINA, @P_CDEMPRESA, @P_CDFILIAL,
                   @V_DTVENC, 'E', '', '');
            /*ATUALIZA O VALOR DA CONTA COM O AJUSTE GERADO*/
            UPDATE CONTARECEBER
               SET VRATUAREC = VRATUAREC - @V_VRAJUSTE
             WHERE CDFILIAL = @P_CDFILIAL
               AND NRLANCTONF = @P_NRLANCTONF
               AND NRSEQVENREC = @V_NRSEQVENREC
               AND NRPARCELAREC = '00';
            /*ATUALIZA O VALOR DO BOLETO COM O AJUSTE GERADO*/
            UPDATE BOLETRECEBER
               SET VRFINALBREC = VRFINALBREC - @V_VRAJUSTE,
                   VRBOLREC = VRBOLREC - @V_VRAJUSTE
             WHERE CDFILIAL = @P_CDFILIAL
               AND NRLANBOLREC = @V_NRLANBOL;
            /*ATUALIZA VALOR DO TIPO DE RECEBIMENTO DO BOLETO*/
            UPDATE TPRECBOLETO
               SET VRTPRECBOLR = VRTPRECBOLR - @V_VRAJUSTE
             WHERE CDFILIAL = @P_CDFILIAL
               AND NRLANBOLREC = @V_NRLANBOL
               AND NRSEQTPRECBO = '01';
         END;

         SET @V_VRRATEIOCONTA = @V_VRCONTA - @V_VRAJUSTE;

         /*GERA O RATEIO DA CONTA*/
         EXEC GERA_RATEIO_CONTA @P_IDENTRSAID, @P_CDFILIAL, @P_NRLANCTONF, @V_NRSEQVENREC,
                                '00', @V_VRRATEIOCONTA, @V_CDTIPOCONTA, @P_FILIORIGEM;

         /*VENCIMENTO DA PRXIMA CONTA*/
         SET @V_DTVENC = DATEADD(MM, 1, @V_DTVENC);

         SET @V_COUNT = @V_COUNT + 1;
         SET @V_VRNEXTLANBOL = CONVERT(DOUBLE PRECISION, @V_NRLANBOL) + 1;
         /*ATUALIZA O NMERO PARA O PRXIMO BOLETO*/
         SET @V_NRLANBOL = RIGHT(REPLICATE('0', 2) + CONVERT(VARCHAR, @V_VRNEXTLANBOL), 2);
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_CONTA','5.05.061';
GO
