IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'ATUALIZA_VERIFCONSSOLOL' AND
      	        TYPE = 'P' 			         AND
	              U.UID = O.UID             	AND
      	        U.NAME = USER)

DROP TRIGGER ATUALIZA_VERIFCONSSOLOL
GO

CREATE TRIGGER ATUALIZA_VERIFCONSSOLOL ON ITEMSOLI
FOR UPDATE
AS
DECLARE @NEW_NRSEQUCONSOL VARCHAR(10);
DECLARE @OLD_CDFILSOLI    VARCHAR(4);
DECLARE @OLD_CDFILLAN     VARCHAR(4);
DECLARE @OLD_DTPROGENTR   DATETIME;
DECLARE @OLD_NRSOLICMP    VARCHAR(20);
DECLARE @OLD_CDPRODUTO;   VARCHAR(10);

BEGIN
   SELECT
       @OLD_CDFILSOLI    = D.CDFILSOLI,
       @OLD_CDFILLAN     = D.CDFILLAN,
       @OLD_DTPROGENTR   = D.DTPROGENTR,
       @OLD_NRSOLICMP    = D.NRSOLICMP,
       @OLD_CDPRODUTO    = D.CDPRODUTO,
       @NEW_NRSEQUCONSOL = I.NRSEQUCONSOL
   FROM
      INSERTED I, DELETED D
   WHERE I.CDFILSOLI  = D.CDFILSOLI
     AND I.CDFILLAN   = D.CDFILLAN
     AND I.DTPROGENTR = D.DTPROGENTR
     AND I.NRSOLICMP  = D.NRSOLICMP
     AND I.CDPRODUTO  = D.CDPRODUTO;
   IF @NEW_NRSEQUCONSOL IS NOT NULL BEGIN
      UPDATE VERIFCONSSOLOL
         SET VERIFCONSSOLOL.NRSEQUCONSOL  = @NEW_NRSEQUCONSOL
       WHERE VERIFCONSSOLOL.CDFILSOLI     = @OLD_CDFILSOLI
         AND VERIFCONSSOLOL.CDFILLAN      = @OLD_CDFILLAN
         AND VERIFCONSSOLOL.DTPROGENTR    = @OLD_DTPROGENTR
         AND VERIFCONSSOLOL.NRSOLICMP     = @OLD_NRSOLICMP
         AND VERIFCONSSOLOL.CDPRODUTO     = @OLD_CDPRODUTO;
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_VERIFCONSSOLOL','5.50.XXX';
GO
